local version = "1.0.13"
--see interface verion
--/run print(GetBuildInfo());

local frame = CreateFrame("Frame")
frame:SetFrameStrata("LOW")

function enhanceItemTooltip(tooltip, useQuantity)
	if AllinoneMinimalisticSettings.showEnhancedItemTooltipCheckbox then
		local name, link = tooltip:GetItem()
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
		itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(link)
		
		--|TInterface\\Icons\\INV_Misc_Coin_01:16|t
		if itemTexture ~= nil then
			tooltip:AppendText("  |T"..itemTexture..":16|t")
		end
		
		--quantity1 = GetMouseFocus().count
		--quantity2 = GetMouseFocus().Quantity
		--tooltip:AddLine("debug_count1: "..tostring(quantity1).."")
		--tooltip:AddLine("debug_count2: "..tostring(quantity2).."")
		
		local quantity = 1
		
		if useQuantity and GetMouseFocus() ~= nil then
		-- this can give an icorrect amount
			--quantity = tonumber(GetMouseFocus().Count:GetText())
			if GetMouseFocus().count ~= nil then
				quantity = GetMouseFocus().count
			elseif GetMouseFocus().Count ~= nil and GetMouseFocus().Count:GetText() ~= nil then
				quantity = tonumber(GetMouseFocus().Count:GetText())
			end
			
			if quantity == nil or (type(quantity) ~= "number") then
				quantity = 1
			end
		end
		
		tooltip:AddLine("Additional info:")
		tooltip:AddLine(string.format("|c80A0A0A0Old item level: %d", itemLevel), 1, 1, 1)
		--if itemStackCount ~= nil and itemStackCount > 1 then
		if itemStackCount ~= nil then
			tooltip:AddLine(string.format("|cFFf1f1f1Max stack size: %s", itemStackCount))
		end
		if quantity > 1 then
			tooltip:AddLine(string.format("|cFFf1f1f1Current stack size: %s", quantity))
		end
		--cc801a
		if quantity ~= nil and itemSellPrice ~= nil then
		 tooltip:AddLine(GetCoinTextureString(itemSellPrice*quantity), 1, 1, 1)
		end
		if quantity ~= nil and quantity > 1 and itemSellPrice ~= nil then
			tooltip:AddDoubleLine("|cFFcc801aSell one: ", GetCoinTextureString(itemSellPrice), 0.3, 0.5, 0.4, 1, 1, 1)
			--tooltip:AddDoubleLine("|cFFcc801aSell one: ", GetCoinText(itemSellPrice, 14), 0.3, 0.5, 0.4, 1, 1, 1)
		end
		if itemStackCount ~= nil and itemStackCount > 1 then
			tooltip:AddDoubleLine(string.format("|cFFcc801aSell stack (|cFFaf5529%s|cFFcc801a): ", itemStackCount), GetCoinTextureString(itemSellPrice*itemStackCount), 0.3, 0.5, 0.4, 1, 1, 1)
		end
		if itemType ~= nil and itemSubType ~= nil then
			if itemType ~= itemSubType then
				tooltip:AddLine(string.format("|cFF9966ccItem type: %s - %s", itemType, itemSubType), 0.3, 0.5, 0.4)
			else
				tooltip:AddLine(string.format("|cFF9966ccItem type: %s", itemType), 0.3, 0.5, 0.4)
			end	
		end
	end
end

GameTooltip:SetScript("OnTooltipSetItem", function(self)
	showComparison(self)
	enhanceItemTooltip(GameTooltip, true)
end)

ItemRefTooltip:SetScript("OnTooltipSetItem", function(self)
	showComparison(self)
	enhanceItemTooltip(ItemRefTooltip, false)
end)

ShoppingTooltip1:SetScript("OnTooltipSetItem", function(self)
	enhanceItemTooltip(ShoppingTooltip1, false)
end)

ShoppingTooltip2:SetScript("OnTooltipSetItem", function(self)
	enhanceItemTooltip(ShoppingTooltip2, false)
end)

function showComparison(self)
    --self:StopMovingOrSizing();
	--ValidateFramePosition(self);
--Auto show item comparison
	if AllinoneMinimalisticSettings.autoShowItemEquipmentComparisonCheckbox then
		if not self:IsEquippedItem() then
			GameTooltip_ShowCompareItem(self)
			self.comparing = true
		end
	end
end

function updateAll()

end

addonIsLoaded = false

function handleEvent(self, event, arg1, ...) 
	if (event == "BAG_UPDATE") then
		--do nothing
	elseif event == "UNIT_HEALTH" then
		--do nothing
	elseif event == "AUCTION_HOUSE_SHOW" then
		--do nothing
	elseif event == "AUCTION_HOUSE_CLOSED" then
		--do nothing
	end
end

--/run print((select(4, GetBuildInfo())));
--/run print(GetBuildInfo());

function dispatchEvents(self, event, arg1, ...)
	if event == "ADDON_LOADED" and arg1 == "AllinoneMinimalistic" then
	    print(string.format("%s v%s is loaded susscessfully\nThank you for using my addon", arg1, version));
		initSettings()
		addonIsLoaded = true
	end
	if addonIsLoaded then
		handleEvent(self, event, arg1, ...)
	end	
end

function loadDefaultSettings() 
	AllinoneMinimalisticSettings = {
		  showEnhancedItemTooltipCheckbox=true,
		  autoShowItemEquipmentComparisonCheckbox=true
	  }
end

function initSettings()
	local optionsFrame = CreateFrame( "Frame", "optionsFrame", UIParent )
	optionsFrame.name = "All in one minimalistic"
	InterfaceOptions_AddCategory(optionsFrame)
	
	if AllinoneMinimalisticSettings == nil then
		loadDefaultSettings()
		print("unable to load AllinoneMinimalistic saved data, backing up to defaults")
	else	
		if AllinoneMinimalisticSettings.showEnhancedItemTooltipCheckbox == nil then
			AllinoneMinimalisticSettings.showEnhancedItemTooltipCheckbox=true
			print("AllinoneMinimalistic.showEnhancedItemTooltip is a new feature, enabling by default")
		end
		if AllinoneMinimalisticSettings.autoShowItemEquipmentComparisonCheckbox == nil then
			AllinoneMinimalisticSettings.autoShowItemEquipmentComparisonCheckbox=true
			print("AllinoneMinimalistic.autoShowEquipmentComparison is a new feature, enabling by default")
		end
		print("AllinoneMinimalistic saved data loaded")
	end	
		
	local showEnhancedItemTooltipCheckbox = CreateFrame("CheckButton", "showEnhancedItemTooltipCheckbox", optionsFrame, "UICheckButtonTemplate")
	showEnhancedItemTooltipCheckbox:SetPoint("TOPLEFT",0,0)
	showEnhancedItemTooltipCheckbox.text:SetText("Show enhanced item tooltip")
	showEnhancedItemTooltipCheckbox:SetChecked(AllinoneMinimalisticSettings.showEnhancedItemTooltipCheckbox)
	showEnhancedItemTooltipCheckbox:SetScript("OnClick",
		function()
			AllinoneMinimalisticSettings.showEnhancedItemTooltipCheckbox=not AllinoneMinimalisticSettings.showEnhancedItemTooltipCheckbox 
			updateAll() 
		end)	
		
	local autoShowItemEquipmentComparisonCheckbox = CreateFrame("CheckButton", "autoShowItemEquipmentComparisonCheckbox", optionsFrame, "UICheckButtonTemplate")
	autoShowItemEquipmentComparisonCheckbox:SetPoint("TOPLEFT",0,-30)
	autoShowItemEquipmentComparisonCheckbox.text:SetText("Automatically show equipment comparison on an equippable item")
	autoShowItemEquipmentComparisonCheckbox:SetChecked(AllinoneMinimalisticSettings.autoShowItemEquipmentComparisonCheckbox)
	autoShowItemEquipmentComparisonCheckbox:SetScript("OnClick",
		function()
			AllinoneMinimalisticSettings.autoShowItemEquipmentComparisonCheckbox=not AllinoneMinimalisticSettings.autoShowItemEquipmentComparisonCheckbox 
			updateAll() 
		end)	
end

function init()
	frame:SetScript("OnEvent", dispatchEvents)
	frame:RegisterEvent("ADDON_LOADED")
end

--Init
init()
